/* $Id: arch_udp.c,v 1.3 2009-01-28 12:59:16 potyra Exp $ 
 *
 * Copyright (C) 2008-2009 FAUmachine Team <info@faumachine.org>.
 * This program is free software. You can redistribute it and/or modify it
 * under the terms of the GNU General Public License, either version 2 of
 * the License, or (at your option) any later version. See COPYING.

 */

#ifdef INCLUDE

#include <assert.h>
#include <stdio.h>
#include <netinet/ip.h>
#include <netinet/udp.h>

#endif /* INCLUDE */

#ifdef STATE
#endif /* STATE */

#ifdef BEHAVIOR

static void
NAME_(from_dhcp)(
	struct cpssp *cpssp,
	const unsigned char *buf,
	unsigned int len
)
{
	NAME_(to_local_ip)(cpssp, buf, len);
}

static void
NAME_(from_local_ip)(
	struct cpssp *cpssp,
	const unsigned char *buf,
	unsigned int len
)
{
	const struct ip *iphdr = (const struct ip *) buf;
	const struct udphdr *udphdr = (const struct udphdr *) (iphdr + 1);

	switch (ntohs(udphdr->uh_dport)) {
	case 67: /* DHCP */
		NAME_(to_dhcp)(cpssp, buf, len);
		break;
	case 68: /* DHCP reply */
		/* Just ignore it... */
		break;
	default:
		fprintf(stderr, "FAUmachine: WARNING: %s %u.\n",
				__FUNCTION__, ntohs(udphdr->uh_dport));
		break;
	}
}

static void
NAME_(create)(struct cpssp *cpssp)
{
}

static void
NAME_(destroy)(struct cpssp *cpssp)
{
}

#endif /* BEHAVIOR */
