/*
 * $Id: ide_gen_disk_gui.c,v 1.14 2009-10-16 11:17:22 vrsieh Exp $
 *
 * Copyright (C) 2003-2009 FAUmachine Team <info@faumachine.org>.
 * This program is free software. You can redistribute it and/or modify it
 * under the terms of the GNU General Public License, either version 2 of
 * the License, or (at your option) any later version. See COPYING.
 */

#include <assert.h>

#include "config.h"

#include "glue-gui.h"

#include "ide_gen_disk_gui.h"

#ifdef HAVE_GTK
#include "ide_gen_disk_gui_gtk.h"
#endif

void *
ide_gen_disk_gui_create(
	unsigned int page,
	const char *name,
	const char *image,
	const char *cylinders,
	const char *heads,
	const char *sectors,
	const char *unit,
	const char *size,
	struct sig_manage *port_manage,
	struct sig_power_device *port_power,
	struct sig_ide_bus *port_ide
)
{
	switch (selected_gui) {
#ifdef HAVE_GTK
	case GUI_GTK:
		return ide_gen_disk_gui_gtk_create(page, name,
				image,
				cylinders, heads, sectors, unit, size,
				port_manage, port_power, port_ide);
		break;
#endif
	case GUI_NULL:
		return (void *) 1;
	default:
		assert(0);
	}

}

void
ide_gen_disk_gui_destroy(void *_cpssp)
{
	switch (selected_gui) {
#ifdef HAVE_GTK
	case GUI_GTK:
		return ide_gen_disk_gui_gtk_destroy(_cpssp);
		break;
#endif
	case GUI_NULL:
		break;
	default:
		assert(0);
	}
}
